function Create(self)
self.PI = 3.14159265358;
self.LBoost = CreateAEmitter("Nil Engine","SWAT Kats.rte");
self.RBoost = CreateAEmitter("Nil Engine","SWAT Kats.rte");
self.CBoost = CreateAEmitter("Nil Engine","SWAT Kats.rte");
self.LateralBoost = CreateAEmitter("Nil Engine","SWAT Kats.rte");
MovableMan:AddParticle(self.LBoost);
MovableMan:AddParticle(self.RBoost);
MovableMan:AddParticle(self.CBoost);
MovableMan:AddParticle(self.LateralBoost);
self.LBID = self.LBoost.ID;
self.RBID = self.RBoost.ID;
self.CBID = self.CBoost.ID;
self.LatBID = self.LateralBoost.ID;
self.LPush = 5000;
self.RPush = 5000;
self.CPush = 10000;
self.LatPush = 0;
self.GotCorpse = false;

self.Facing = 0;

self.Autopilot = false;

self.FlightAssist = true;
self.SafeDescendRate = 4;
self.SafeAltitude = 200;

self.TargetRoll = 0;
self.TargetClimbRate = 0;
self.TargetVelocity = 0;
self.TargetRollRate = 0;
self.MaintainAltitude = true;
self.TargetAltitude = self.Pos.Y;
end

function Destroy(self)
if MovableMan:IsParticle(self.LBoost) then
	self.LBoost:GibThis(Vector(0,0),0,self.LBoost.Parent);
end
if MovableMan:IsParticle(self.RBoost) then
	self.RBoost:GibThis(Vector(0,0),0,self.RBoost.Parent);
end
if MovableMan:IsParticle(self.CBoost) then
	self.CBoost:GibThis(Vector(0,0),0,self.CBoost.Parent);
end
if MovableMan:IsParticle(self.LateralBoost) then
	self.LateralBoost:GibThis(Vector(0,0),0,self.LateralBoost.Parent);
end
if self.GotCorpse and SceneMan:IsWithinBounds(self.Pos.X,self.Pos.Y,0) then
	--self.Corpse.AngularVel = self.AngularVel;
	self.Corpse.Pos = self.Pos;
	self.Corpse.Vel = self.Vel;
	--self.Corpse.RotAngle = self.RotAngle;
	MovableMan:AddMO(self.Corpse);
end
end

function Update(self)
	--Update boosters
	self.TargetRoll = 0;
	self.TargetClimbRate = 0;
	self.TargetVelocity = 0;
	self.TargetRollRate = 0;
	self.MaintainAltitude = true;

	--start control
	--toggle autopilot
	if self:GetController():IsPlayerControlled(1) and UInputMan:KeyPressed(26) then
		if self.Autopilot then
			self.Autopilot = false;
		else
			self.Autopilot = true;
		end
	end

	if self:GetController():IsPlayerControlled(1) and UInputMan:KeyPressed(24) then
		if self.FlightAssist then
			self.FlightAssist = false;
		else
			self.FlightAssist = true;
		end
	end

	--check rotation
	if self:GetController():IsPlayerControlled(1) and UInputMan:KeyPressed(18) then
		self.Facing = self.Facing +1;
		if self.Facing > 1 then
			self.Facing = -1;
		end
	end
	if self:GetController():IsPlayerControlled(1) and UInputMan:KeyPressed(20) then
		self.Facing = self.Facing -1;
		if self.Facing < -1 then
			self.Facing = 1;
		end
	end

	--update facing and vars
	if self.Facing == 0 then
		self.Frame = 0;
		self.LBPos = Vector(28,-9);
		self.RBPos = Vector(-28,-9);
		self.CBPos = Vector(0,-20);
		self.LatBPos = Vector(0,-20);
		self.LBRot = (self.PI/2)+0.3;
		self.RBRot = (self.PI/2)-0.3;
		self.CBRot = (self.PI/2);
		self.LatBRot = (self.PI/2);
		self.LOPush = 6000;
		self.ROPush = 6000;
		self.COPush = 4000;
		self.LatOPush = 0;
	end
	if self.Facing == 1 then
		self.Frame = 1;
		self.LBPos = Vector(-30,-9);
		self.RBPos = Vector(-30,-9);
		self.CBPos = Vector(100,-20);
		self.LatBPos = Vector(120,0);
		self.LBRot = (self.PI/2)-0.5;
		self.RBRot = (self.PI/2)-0.5;
		self.CBRot = (self.PI/2)+0.5;		
		self.LatBRot = self.PI;
		self.LOPush = 6000;
		self.ROPush = 6000;
		self.COPush = 4000;
		self.LatOPush = 1000;
	end
	if self.Facing == -1 then
		self.Frame = 2;
		self.LBPos = Vector(30,-9);
		self.RBPos = Vector(30,-9);
		self.CBPos = Vector(-100,-20);
		self.LatBPos = Vector(-120,0);
		self.LBRot = (self.PI/2)+0.5;
		self.RBRot = (self.PI/2)+0.5;
		self.CBRot = (self.PI/2)-0.5;		
		self.LatBRot = 0;
		self.LOPush = 6000;
		self.ROPush = 6000;
		self.COPush = 4000;
		self.LatOPush = 1000;
	end
	self.LTPush = self.LOPush;
	self.RTPush = self.ROPush;
	self.CTPush = self.COPush;
	self.LatTPush = self.LatOPush;

	--check autopilot
	if self.Autopilot then
		if self:GetController():IsState(Controller.HOLD_LEFT) then
			self.TargetVelocity = self.TargetVelocity - 10;
			--ConsoleMan:PrintString("Control Input MOVE LEFT; setting Target Velocity LOW");
		end
		if self:GetController():IsState(Controller.HOLD_RIGHT) then
			self.TargetVelocity = self.TargetVelocity + 10;
			--ConsoleMan:PrintString("Control Input MOVE RIGHT; setting Target Velocity HIGH");
		end
		if self:GetController():IsState(Controller.HOLD_DOWN) then
			self.TargetClimbRate = self.TargetClimbRate + 4;
			self.MaintainAltitude = false;
			self.TargetAltitude = self.Pos.Y;
			--ConsoleMan:PrintString("Control Input MOVE DOWN; setting Climbrate HIGH (Y reverse)");
		end
		if self:GetController():IsState(Controller.HOLD_UP) then
			self.TargetClimbRate = self.TargetClimbRate - 4;
			self.MaintainAltitude = false;
			self.TargetAltitude = self.Pos.Y;
			--ConsoleMan:PrintString("Control Input MOVE UP; setting Target Velocity LOW (Y reverse)");
		end

	--apply autopilot
	--if velocity far less than target, adjust target roll (or use boost)
	if math.abs(self.Vel.X - self.TargetVelocity)>1 then --and math.abs(self.RotAngle-self.TargetRoll)>self.PI/60 then
		if self.Vel.X < self.TargetVelocity then
			if self.Facing == -1 then
				self.LatTPush = self.LatTPush * 10;
			else
			self.TargetRoll = -1*self.PI/6;
			end
			--ConsoleMan:PrintString("Velocity too low; Adjusting target roll to RIGHT");
		end
		if self.Vel.X > self.TargetVelocity then
			if self.Facing == 1 then
				self.LatTPush = self.LatTPush * 10;
			else
			self.TargetRoll = self.PI/6;
			end
			--ConsoleMan:PrintString("Velocity too high; Adjusting target roll to LEFT");
		end
	end
	--if velocity far less than target and rotation sufficient, apply thrust to stop rotation
	if math.abs(self.Vel.X - self.TargetVelocity)>5 and math.abs(self.RotAngle-self.TargetRoll)<self.PI/60 then
		self.TargetRoll = self.RotAngle;
		--self.CTPush = self.CTPush*5;
		--ConsoleMan:PrintString("Velocity too low; Roll sufficient; Fixing ROLL");
	end
	--if velocity near target and rotation sufficient, adjust target roll and decelerate
	if math.abs(self.Vel.X - self.TargetVelocity)<1 and math.abs(self.RotAngle-self.TargetRoll)<=self.PI/60 and math.abs(self.TargetVelocity)>0 then
		if self.Vel.X > self.TargetVelocity then
			self.TargetRoll = self.PI/90;
			--ConsoleMan:PrintString("Velocity sufficient; Adjusting roll to LEVEL");
		end
		if self.Vel.X < self.TargetVelocity then
			self.TargetRoll = -1*self.PI/90;
			--ConsoleMan:PrintString("Velocity sufficient; Adjusting roll to LEVEL");
		end
	end
	--if altitude low, adjust climb rate
	if self.MaintainAltitude then
	if math.abs(self.Pos.Y - self.TargetAltitude)>5 then
		if self.TargetAltitude < self.Pos.Y then
			self.TargetClimbRate = (self.TargetAltitude-self.Pos.Y)/10;
			--ConsoleMan:PrintString("Altitude too low; setting Climbrate HIGH (Y reverse)");
		end
		if self.TargetClimbRate > self.Pos.Y then
			self.TargetClimbRate = (self.Pos.Y-self.TargetAltitude)/10;
			--ConsoleMan:PrintString("Altitude too high; setting Climbrate LOW (Y reverse)");
		end
	end
	end
	
	--if climb rate different, adjust thrust
	if math.abs(self.Vel.Y - self.TargetClimbRate)>0.5 then
		if self.TargetClimbRate < self.Vel.Y then
			if self.Facing == 0 then
			self.CTPush = self.CTPush * 5;
			self.LTPush = self.LTPush * 2;
			self.RTPush = self.RTPush * 2;
			end
			if self.Facing == 1 or self.Facing == -1 then
			self.CTPush = self.CTPush * 2;
			self.LTPush = self.LTPush * 2;
			self.RTPush = self.RTPush * 2;
			end
			--ConsoleMan:PrintString("Climbrate insufficient; setting Thrust to HIGH");
		end
		if self.TargetClimbRate > self.Vel.Y then
			if self.Facing == 0 then
			self.CTPush = self.CTPush * 0.1;
			self.LTPush = self.LTPush * 0.3;
			self.RTPush = self.RTPush * 0.3;
			end
			if self.Facing == 1 or self.Facing == -1 then
			self.CTPush = self.CTPush * 0.1;
			self.LTPush = self.LTPush * 0.1;
			self.RTPush = self.RTPush * 0.1;
			end
			--ConsoleMan:PrintString("Climbrate excessive; setting Thrust to LOW");
		end
	end

	--if rotation too great, adjust desired rotation speed
	if math.abs(self.RotAngle - self.TargetRoll)>self.PI/180 then
		if self.TargetRoll < self.RotAngle then
			self.TargetRollRate = -1*self.PI/18*(self.RotAngle/self.TargetRoll);
			--ConsoleMan:PrintString("Roll target different; rotating RIGHT");
		end
		if self.TargetRoll > self.RotAngle then
			self.TargetRollRate = self.PI/18*(self.TargetRoll/self.RotAngle);
			--ConsoleMan:PrintString("Roll target different; rotating LEFT");
		end
	end
	--if rotation speed different, adjust thrust
	if math.abs(self.AngularVel - self.TargetRollRate)>self.PI/1800 then
		if self.TargetRollRate < self.AngularVel then
			if self.Facing == 0 then
			self.LTPush = self.LTPush * 0;
			self.RTPush = self.RTPush * 3;
			end
			if self.Facing == -1 then
			self.CTPush = self.CTPush * 2;
			self.LTPush = self.LTPush * 0.9;
			self.RTPush = self.RTPush * 0.9;
			end
			if self.Facing == 1 then
			self.CTPush = self.CTPush * -0.2;
			self.LTPush = self.LTPush * 2;
			self.RTPush = self.RTPush * 2;
			end
			--ConsoleMan:PrintString("Rolling clockwise too fast; Adjusting thrust bias to RIGHT");
		end
		if self.TargetRollRate > self.AngularVel then
			if self.Facing == 0 then
			self.LTPush = self.LTPush * 3;
			self.RTPush = self.RTPush * 0;
			end
			if self.Facing == 1 then
			self.CTPush = self.CTPush * 2;
			self.LTPush = self.LTPush * 0.9;
			self.RTPush = self.RTPush * 0.9;
			end
			if self.Facing == -1 then
			self.CTPush = self.CTPush * 0;
			self.LTPush = self.LTPush * 2;
			self.RTPush = self.RTPush * 2;
			end
			--ConsoleMan:PrintString("Rolling counterclockwise too fast; Adjusting thrust bias to LEFT");
		end
	end


	else --manual (not recommended)

		self.TargetAltitude = self.Pos.Y;

	--apply flight assist

	if self.FlightAssist then
		if self.Vel.Y > self.SafeDescendRate then
			if not self:GetController():IsState(Controller.HOLD_UP) then
				if self.Facing == 0 then
				self.CTPush = self.CTPush * 5;
				self.LTPush = self.LTPush * 1.2;
				self.RTPush = self.RTPush * 1.2;
				end
				if self.Facing == 1 or self.Facing == -1 then
				self.CTPush = self.CTPush * 3;
				self.LTPush = self.LTPush * 3;
				self.RTPush = self.RTPush * 3;
				end
			end
		end
		if SceneMan:FindAltitude(self.Pos,0,10) < self.SafeAltitude then
			if not self:GetController():IsState(Controller.HOLD_UP) then
				if self.Facing == 0 then
				self.CTPush = self.CTPush * 5;
				self.LTPush = self.LTPush * 1.2;
				self.RTPush = self.RTPush * 1.2;
				end
				if self.Facing == 1 or self.Facing == -1 then
				self.CTPush = self.CTPush * 3;
				self.LTPush = self.LTPush * 3;
				self.RTPush = self.RTPush * 3;
				end
			end
		end
	end

	--Alter thrust
		if self:GetController():IsState(Controller.HOLD_LEFT) then
			if self.Facing == 0 then
			self.TargetRoll = self.PI;
			elseif self.Facing == 1 then
			self.LatTPush = self.LatTPush * 10;
			elseif self.Facing == -1 then
			self.LatTPush = self.LatTPush * -1;
			end
		end
		if self:GetController():IsState(Controller.HOLD_RIGHT) then
			if self.Facing == 0 then
			self.TargetRoll = -1*self.PI;
			elseif self.Facing == 1 then
			self.LatTPush = self.LatTPush * -1;
			elseif self.Facing == -1 then
			self.LatTPush = self.LatTPush * 10;
			end
		end
		if self:GetController():IsState(Controller.HOLD_DOWN) then
			if self.Facing == 0 then
			self.CTPush = self.CTPush * 0.1;
			self.LTPush = self.LTPush * 0.3;
			self.RTPush = self.RTPush * 0.3;
			end
			if self.Facing == 1 or self.Facing == -1 then
			self.CTPush = self.CTPush * 0.1;
			self.LTPush = self.LTPush * 0.1;
			self.RTPush = self.RTPush * 0.1;
			end
		end
		if self:GetController():IsState(Controller.HOLD_UP) then
			if self.Facing == 0 then
			self.CTPush = self.CTPush * 5;
			self.LTPush = self.LTPush * 1.2;
			self.RTPush = self.RTPush * 1.2;
			end
			if self.Facing == 1 or self.Facing == -1 then
			self.CTPush = self.CTPush * 3;
			self.LTPush = self.LTPush * 3;
			self.RTPush = self.RTPush * 3;
			end
		end

	--if rotation too great, adjust desired rotation speed
	if math.abs(self.RotAngle - self.TargetRoll)>self.PI/180 then
		if self.TargetRoll < self.RotAngle then
			self.TargetRollRate = -1*self.PI/3;
			--ConsoleMan:PrintString("Roll target different; rotating RIGHT");
		end
		if self.TargetRoll > self.RotAngle then
			self.TargetRollRate = self.PI/3;
			--ConsoleMan:PrintString("Roll target different; rotating LEFT");
		end
	end

	--if rotation speed different, adjust thrust
	if math.abs(self.AngularVel - self.TargetRollRate)>self.PI/1800 then
		if self.TargetRollRate < self.AngularVel then
			if self.Facing == 0 then
			self.LTPush = self.LTPush * 0;
			self.RTPush = self.RTPush * 3;
			end
			if self.Facing == -1 then
			self.CTPush = self.CTPush * 2;
			self.LTPush = self.LTPush * 1.1;
			self.RTPush = self.RTPush * 1.1;
			end
			if self.Facing == 1 then
			self.CTPush = self.CTPush * 0;
			self.LTPush = self.LTPush * 3;
			self.RTPush = self.RTPush * 3;
			end
			--ConsoleMan:PrintString("Rolling clockwise too fast; Adjusting thrust bias to RIGHT");
		end
		if self.TargetRollRate > self.AngularVel then
			if self.Facing == 0 then
			self.LTPush = self.LTPush * 3;
			self.RTPush = self.RTPush * 0;
			end
			if self.Facing == 1 then
			self.CTPush = self.CTPush * 2;
			self.LTPush = self.LTPush * 1.1;
			self.RTPush = self.RTPush * 1.1;
			end
			if self.Facing == -1 then
			self.CTPush = self.CTPush * 0;
			self.LTPush = self.LTPush * 3;
			self.RTPush = self.RTPush * 3;
			end
			--ConsoleMan:PrintString("Rolling counterclockwise too fast; Adjusting thrust bias to LEFT");
		end
	end
	end --end control

	--Tween push
	-- self.CPush = self.CPush + ((self.CTPush - self.CPush)/10)
	if self.CTPush > self.CPush then
		self.CPush = self.CPush + ((self.CTPush - self.CPush)/10);
	end
	if self.LTPush > self.LPush then
		self.LPush = self.LPush + ((self.LTPush - self.LPush)/10);
	end
	if self.RTPush > self.RPush then
		self.RPush = self.RPush + ((self.RTPush - self.RPush)/10);
	end
	if self.CTPush < self.CPush then
		self.CPush = self.CPush - ((self.CPush - self.CTPush)/10);
	end
	if self.LTPush < self.LPush then
		self.LPush = self.LPush - ((self.LPush - self.LTPush)/10);
	end
	if self.RTPush < self.RPush then
		self.RPush = self.RPush - ((self.RPush - self.RTPush)/10);
	end
	if self.LatTPush > self.LatPush then
		self.LatPush = self.LatPush + ((self.LatTPush - self.LatPush)/100);
	end
	if self.LatTPush < self.LatPush then
		self.LatPush = self.LatPush - ((self.LatPush - self.LatTPush)/100);
	end

	--ConsoleMan:PrintString(tostring(self.LBID));
	--ConsoleMan:PrintString(tostring(MovableMan:GetMOFromID(self.LBID)));	

	--Apply proper angle (facing down) and shift position, then add thrust
	if MovableMan:IsParticle(self.LBoost) then
	self.LBoost.RotAngle = self.RotAngle+self.LBRot;
	self.LBoost.Pos.X = self.Pos.X + math.cos(self.LBPos.AbsRadAngle - self.RotAngle)*1*self.LBPos.Magnitude;
	self.LBoost.Pos.Y = self.Pos.Y + math.sin(self.LBPos.AbsRadAngle - self.RotAngle)*1*self.LBPos.Magnitude;
	self:AddAbsForce(Vector(math.cos(self.LBoost.RotAngle)*self.LPush,math.sin(self.LBoost.RotAngle)*-1*self.LPush), self.LBoost.Pos);
	self.LBoost:ClearForces();
	self.LBoost.Scale = self.LOPush / self.LPush;
	end
	if MovableMan:IsParticle(self.RBoost) then
	self.RBoost.RotAngle = self.RotAngle+self.RBRot;
	self.RBoost.Pos.X = self.Pos.X + math.cos(self.RBPos.AbsRadAngle - self.RotAngle)*1*self.RBPos.Magnitude;
	self.RBoost.Pos.Y = self.Pos.Y + math.sin(self.RBPos.AbsRadAngle - self.RotAngle)*1*self.RBPos.Magnitude;
	self:AddAbsForce(Vector(math.cos(self.RBoost.RotAngle)*self.RPush,math.sin(self.RBoost.RotAngle)*-1*self.RPush), self.RBoost.Pos);
	self.RBoost:ClearForces();
	self.RBoost.Scale = self.ROPush / self.RPush;
	end
	if MovableMan:IsParticle(self.CBoost) then
	self.CBoost.RotAngle = self.RotAngle+self.CBRot;
	self.CBoost.Pos.X = self.Pos.X + math.cos(self.CBPos.AbsRadAngle - self.RotAngle)*1*self.CBPos.Magnitude;
	self.CBoost.Pos.Y = self.Pos.Y + math.sin(self.CBPos.AbsRadAngle - self.RotAngle)*1*self.CBPos.Magnitude;	
	self:AddAbsForce(Vector(math.cos(self.CBoost.RotAngle)*self.CPush,math.sin(self.CBoost.RotAngle)*-1*self.CPush), self.CBoost.Pos);
	self.CBoost:ClearForces();
	self.CBoost.Scale = self.COPush / self.CPush;
	end
	if MovableMan:IsParticle(self.LateralBoost) then
	self.LateralBoost.RotAngle = self.RotAngle+self.LatBRot;
	self.LateralBoost.Pos.X = self.Pos.X + math.cos(self.LatBPos.AbsRadAngle - self.RotAngle)*1*self.LatBPos.Magnitude;
	self.LateralBoost.Pos.Y = self.Pos.Y + math.sin(self.LatBPos.AbsRadAngle - self.RotAngle)*1*self.LatBPos.Magnitude;	
	self:AddAbsForce(Vector(math.cos(self.LateralBoost.RotAngle)*self.LatPush,math.sin(self.LateralBoost.RotAngle)*-1*self.LatPush), self.LateralBoost.Pos);
	self.LateralBoost:ClearForces();
	self.LateralBoost.Scale = self.LatOPush / self.LatPush;
	end
	
	self:NotResting();

	--[[ConsoleMan:PrintString("Target Altitude");
	ConsoleMan:PrintString(tostring(self.TargetAltitude));
	ConsoleMan:PrintString("Actual Altitude");
	ConsoleMan:PrintString(tostring(self.Pos.Y));
	ConsoleMan:PrintString("Target Velocity");
	ConsoleMan:PrintString(tostring(self.TargetVelocity));
	ConsoleMan:PrintString("Actual Velocity");
	ConsoleMan:PrintString(tostring(self.Vel.X));
	ConsoleMan:PrintString("Target Climbrate");
	ConsoleMan:PrintString(tostring(self.TargetClimbRate));
	ConsoleMan:PrintString("Actual Climbrate");
	ConsoleMan:PrintString(tostring(self.Vel.Y));
	ConsoleMan:PrintString("Target Roll");
	ConsoleMan:PrintString(tostring(self.TargetRoll));
	ConsoleMan:PrintString("Actual Roll");
	ConsoleMan:PrintString(tostring(self.RotAngle));
	ConsoleMan:PrintString("Target Rollrate");
	ConsoleMan:PrintString(tostring(self.TargetRollRate));
	ConsoleMan:PrintString("Actual Rollrate");
	ConsoleMan:PrintString(tostring(self.AngularVel));
	ConsoleMan:PrintString("Left Thruster (target/actual)");
	ConsoleMan:PrintString(tostring(self.LTPush));
	ConsoleMan:PrintString(tostring(self.LPush));
	ConsoleMan:PrintString("Center Thruster (target/actual)");
	ConsoleMan:PrintString(tostring(self.CTPush));
	ConsoleMan:PrintString(tostring(self.CPush));
	ConsoleMan:PrintString("Right Thruster (target/actual)");
	ConsoleMan:PrintString(tostring(self.RTPush));
	ConsoleMan:PrintString(tostring(self.RPush));
	ConsoleMan:PrintString("");
	]]--

--prepare for funeral
		if self.Facing == 0 then
			if not self.GotCorpse then
				self.Corpse = CreateMOSRotating("Turbokat Gib Object Front","SWAT Kats.rte");
				self.GotCorpse = true; --oh for fudge's sake!
			end
		end
			self.Corpse.AngularVel = self.AngularVel;
			self.Corpse.Pos = self.Pos;
			self.Corpse.Vel = self.Vel;
			self.Corpse.RotAngle = self.RotAngle;
		

end